<?php
// $Id$
/**
 * @file transport_retrieve_service.inc
 * Provides services callbacks for transport retrieval.
 */

/**
 * Check if the user has the permission to access the service.
 *
 * TODO, somehow :/
 * We can't know at this point whether the user has the permission to create
 * nodes of the type that Transport module will retrieve.
 * Failure may happen further down the line...
 *
 * @return
 *   Boolean. TRUE if the user has view access.
 */
function transport_retrieve_service_get_access() {
  return user_access('access tranport service');
}

/**
 * Service callback.
 *
 * @return
 *  TRUE for success, FALSE for failure.
 */
function transport_retrieve_service_retrieve($client_endpoint, $entities) {
  // Really bogus: sleep for long enough for the remote site to
  // save its image, etc etc.
  sleep(2); 
  
  // Get the connection based on the endpoint... weak :(
  $connection_id = _transport_retrieve_service_client_get_cid_by_endpoint($client_endpoint);
  $connection = clients_get_connection($connection_id);
  
  // Create our transport controller.
  // Define an arbitrary name to identify the source.
  $source_name = "transport-$connection_id";
  $options = array();
  $transport_controller = new TransportControllerRetriever($source_name, $connection, $options);
  
  // Start the process.
  $processed_list = $transport_controller->beginRetrieval($entities); 
 
  return TRUE; 
}

/**
 * Ugly helper function to get a client cid by its endpoint.
 */
function _transport_retrieve_service_client_get_cid_by_endpoint($endpoint) {
  $result = db_query("SELECT cid FROM {clients_connections} WHERE endpoint = '%s'", $endpoint);
  return db_result($result);
}
